Class: Aws::Billing::Client

Inherits:
Seahorse::Client::Base show all
Includes:
ClientStubs
Defined in:
gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb

Overview

An API client for Billing. To construct a client, you need to configure a :region and :credentials.

client = Aws::Billing::Client.new(
  region: region_name,
  credentials: credentials,
  # ...
)

For details on configuring region and credentials see the developer guide.

See #initialize for a full list of supported configuration options.

Instance Attribute Summary

Attributes inherited from Seahorse::Client::Base

#config, #handlers

API Operations collapse

Instance Method Summary collapse

Methods included from ClientStubs

#api_requests, #stub_data, #stub_responses

Methods inherited from Seahorse::Client::Base

add_plugin, api, clear_plugins, define, new, #operation_names, plugins, remove_plugin, set_api, set_plugins

Methods included from Seahorse::Client::HandlerBuilder

#handle, #handle_request, #handle_response

Constructor Details

#initialize(options) ⇒ Client

Returns a new instance of Client.

Parameters:

  • options (Hash)

Options Hash (options):

  • :plugins (Array<Seahorse::Client::Plugin>) — default: []] —

    A list of plugins to apply to the client. Each plugin is either a class name or an instance of a plugin class.

  • :credentials (required, Aws::CredentialProvider) —

    Your AWS credentials used for authentication. This can be any class that includes and implements Aws::CredentialProvider, or instance of any one of the following classes:

    • Aws::Credentials - Used for configuring static, non-refreshing credentials.

    • Aws::SharedCredentials - Used for loading static credentials from a shared file, such as ~/.aws/config.

    • Aws::AssumeRoleCredentials - Used when you need to assume a role.

    • Aws::AssumeRoleWebIdentityCredentials - Used when you need to assume a role after providing credentials via the web.

    • Aws::SSOCredentials - Used for loading credentials from AWS SSO using an access token generated from aws login.

    • Aws::ProcessCredentials - Used for loading credentials from a process that outputs to stdout.

    • Aws::InstanceProfileCredentials - Used for loading credentials from an EC2 IMDS on an EC2 instance.

    • Aws::ECSCredentials - Used for loading credentials from instances running in ECS.

    • Aws::CognitoIdentityCredentials - Used for loading credentials from the Cognito Identity service.

    When :credentials are not configured directly, the following locations will be searched for credentials:

    • Aws.config[:credentials]

    • The :access_key_id, :secret_access_key, :session_token, and :account_id options.

    • ENV['AWS_ACCESS_KEY_ID'], ENV['AWS_SECRET_ACCESS_KEY'], ENV['AWS_SESSION_TOKEN'], and ENV['AWS_ACCOUNT_ID'].

    • ~/.aws/credentials

    • ~/.aws/config

    • EC2/ECS IMDS instance profile - When used by default, the timeouts are very aggressive. Construct and pass an instance of Aws::InstanceProfileCredentials or Aws::ECSCredentials to enable retries and extended timeouts. Instance profile credential fetching can be disabled by setting ENV['AWS_EC2_METADATA_DISABLED'] to true.

  • :region (required, String) —

    The AWS region to connect to. The configured :region is used to determine the service :endpoint. When not passed, a default :region is searched for in the following locations:

    • Aws.config[:region]
    • ENV['AWS_REGION']
    • ENV['AMAZON_REGION']
    • ENV['AWS_DEFAULT_REGION']
    • ~/.aws/credentials
    • ~/.aws/config
  • :access_key_id (String)
  • :account_id (String)
  • :active_endpoint_cache (Boolean) — default: false —

    When set to true, a thread polling for endpoints will be running in the background every 60 secs (default). Defaults to false.

  • :adaptive_retry_wait_to_fill (Boolean) — default: true —

    Used only in adaptive retry mode. When true, the request will sleep until there is sufficent client side capacity to retry the request. When false, the request will raise a RetryCapacityNotAvailableError and will not retry instead of sleeping.

  • :auth_scheme_preference (Array<String>) —

    A list of preferred authentication schemes to use when making a request. Supported values are: sigv4, sigv4a, httpBearerAuth, and noAuth. When set using ENV['AWS_AUTH_SCHEME_PREFERENCE'] or in shared config as auth_scheme_preference, the value should be a comma-separated list.

  • :client_side_monitoring (Boolean) — default: false —

    When true, client-side metrics will be collected for all API requests from this client.

  • :client_side_monitoring_client_id (String) — default: "" —

    Allows you to provide an identifier for this client which will be attached to all generated client side metrics. Defaults to an empty string.

  • :client_side_monitoring_host (String) — default: "127.0.0.1" —

    Allows you to specify the DNS hostname or IPv4 or IPv6 address that the client side monitoring agent is running on, where client metrics will be published via UDP.

  • :client_side_monitoring_port (Integer) — default: 31000 —

    Required for publishing client metrics. The port that the client side monitoring agent is running on, where client metrics will be published via UDP.

  • :client_side_monitoring_publisher (Aws::ClientSideMonitoring::Publisher) — default: Aws::ClientSideMonitoring::Publisher —

    Allows you to provide a custom client-side monitoring publisher class. By default, will use the Client Side Monitoring Agent Publisher.

  • :convert_params (Boolean) — default: true —

    When true, an attempt is made to coerce request parameters into the required types.

  • :correct_clock_skew (Boolean) — default: true —

    Used only in standard and adaptive retry modes. Specifies whether to apply a clock skew correction and retry requests with skewed client clocks. Takes effect only when disable_clock_skew_correction is not set.

  • :defaults_mode (String) — default: "legacy" —

    See DefaultsModeConfiguration for a list of the accepted modes and the configuration defaults that are included.

  • :disable_clock_skew_correction (Boolean) —

    Used only in standard and adaptive retry modes. When true, the SDK does not apply a clock skew correction, does not update its stored skew from responses, and does not retry clock skew errors. Clock skew correction is enabled by default.

  • :disable_host_prefix_injection (Boolean) — default: false —

    When true, the SDK will not prepend the modeled host prefix to the endpoint.

  • :disable_request_compression (Boolean) — default: false —

    When set to 'true' the request body will not be compressed for supported operations.

  • :endpoint (String, URI::HTTPS, URI::HTTP) —

    Normally you should not configure the :endpoint option directly. This is normally constructed from the :region option. Configuring :endpoint is normally reserved for connecting to test or custom endpoints. The endpoint should be a URI formatted like:

    'http://example.com'
    'https://example.com'
    'http://example.com:123'
    
  • :endpoint_cache_max_entries (Integer) — default: 1000 —

    Used for the maximum size limit of the LRU cache storing endpoints data for endpoint discovery enabled operations. Defaults to 1000.

  • :endpoint_cache_max_threads (Integer) — default: 10 —

    Used for the maximum threads in use for polling endpoints to be cached, defaults to 10.

  • :endpoint_cache_poll_interval (Integer) — default: 60 —

    When :endpoint_discovery and :active_endpoint_cache is enabled, Use this option to config the time interval in seconds for making requests fetching endpoints information. Defaults to 60 sec.

  • :endpoint_discovery (Boolean) — default: false —

    When set to true, endpoint discovery will be enabled for operations when available.

  • :ignore_configured_endpoint_urls (Boolean) —

    Setting to true disables use of endpoint URLs provided via environment variables and the shared configuration file.

  • :log_formatter (Aws::Log::Formatter) — default: Aws::Log::Formatter.default —

    The log formatter.

  • :log_level (Symbol) — default: :info —

    The log level to send messages to the :logger at.

  • :logger (Logger) —

    The Logger instance to send log messages to. If this option is not set, logging will be disabled.

  • :max_attempts (Integer) — default: 3 —

    An integer representing the maximum number attempts that will be made for a single request, including the initial attempt. For example, setting this value to 5 will result in a request being retried up to 4 times. Used in standard and adaptive retry modes.

  • :profile (String) — default: "default" —

    Used when loading credentials from the shared credentials file at HOME/.aws/credentials. When not specified, 'default' is used.

  • :request_checksum_calculation (String) — default: "when_supported" —

    Determines when a checksum will be calculated for request payloads. Values are:

    • when_supported - (default) When set, a checksum will be calculated for all request payloads of operations modeled with the httpChecksum trait where requestChecksumRequired is true and/or a requestAlgorithmMember is modeled.
    • when_required - When set, a checksum will only be calculated for request payloads of operations modeled with the httpChecksum trait where requestChecksumRequired is true or where a requestAlgorithmMember is modeled and supplied.
  • :request_min_compression_size_bytes (Integer) — default: 10240 —

    The minimum size in bytes that triggers compression for request bodies. The value must be non-negative integer value between 0 and 10485780 bytes inclusive.

  • :response_checksum_validation (String) — default: "when_supported" —

    Determines when checksum validation will be performed on response payloads. Values are:

    • when_supported - (default) When set, checksum validation is performed on all response payloads of operations modeled with the httpChecksum trait where responseAlgorithms is modeled, except when no modeled checksum algorithms are supported.
    • when_required - When set, checksum validation is not performed on response payloads of operations unless the checksum algorithm is supported and the requestValidationModeMember member is set to ENABLED.
  • :retry_backoff (Proc) —

    A proc or lambda used for backoff. Defaults to 2**retries * retry_base_delay. This option is only used in the legacy retry mode.

  • :retry_base_delay (Float) — default: 0.3 —

    The base delay in seconds used by the default backoff function. This option is only used in the legacy retry mode.

  • :retry_jitter (Symbol) — default: :none —

    A delay randomiser function used by the default backoff function. Some predefined functions can be referenced by name - :none, :equal, :full, otherwise a Proc that takes and returns a number. This option is only used in the legacy retry mode.

    @see https://www.awsarchitectureblog.com/2015/03/backoff.html

  • :retry_limit (Integer) — default: 3 —

    The maximum number of times to retry failed requests. Only ~ 500 level server errors and certain ~ 400 level client errors are retried. Generally, these are throttling errors, data checksum errors, networking errors, timeout errors, auth errors, endpoint discovery, and errors from expired credentials. This option is only used in the legacy retry mode.

  • :retry_max_delay (Integer) — default: 0 —

    The maximum number of seconds to delay between retries (0 for no limit) used by the default backoff function. This option is only used in the legacy retry mode.

  • :retry_mode (String) — default: "legacy" —

    Specifies which retry algorithm to use. Values are:

    • legacy - The pre-existing retry behavior. This is the default value if no retry mode is provided.

    • standard - A standardized set of retry rules across the AWS SDKs. This includes support for retry quotas, which limit the number of unsuccessful retries a client can make.

    • adaptive - A retry mode that includes all the functionality of standard mode along with automatic client side throttling.

  • :sdk_ua_app_id (String) —

    A unique and opaque application ID that is appended to the User-Agent header as app/sdk_ua_app_id. It should have a maximum length of 50. This variable is sourced from environment variable AWS_SDK_UA_APP_ID or the shared config profile attribute sdk_ua_app_id.

  • :secret_access_key (String)
  • :session_token (String)
  • :sigv4a_signing_region_set (Array) —

    A list of regions that should be signed with SigV4a signing. When not passed, a default :sigv4a_signing_region_set is searched for in the following locations:

    • Aws.config[:sigv4a_signing_region_set]
    • ENV['AWS_SIGV4A_SIGNING_REGION_SET']
    • ~/.aws/config
  • :simple_json (Boolean) — default: false —

    Disables request parameter conversion, validation, and formatting. Also disables response data type conversions. The request parameters hash must be formatted exactly as the API expects.This option is useful when you want to ensure the highest level of performance by avoiding overhead of walking request parameters and response data structures.

  • :stub_responses (Boolean) — default: false —

    Causes the client to return stubbed responses. By default fake responses are generated and returned. You can specify the response data to return or errors to raise by calling ClientStubs#stub_responses. See ClientStubs for more information.

    Please note When response stubbing is enabled, no HTTP requests are made, and retries are disabled.

  • :telemetry_provider (Aws::Telemetry::TelemetryProviderBase) — default: Aws::Telemetry::NoOpTelemetryProvider —

    Allows you to provide a telemetry provider, which is used to emit telemetry data. By default, uses NoOpTelemetryProvider which will not record or emit any telemetry data. The SDK supports the following telemetry providers:

    • OpenTelemetry (OTel) - To use the OTel provider, install and require the opentelemetry-sdk gem and then, pass in an instance of a Aws::Telemetry::OTelProvider for telemetry provider.
  • :token_provider (Aws::TokenProvider) —

    Your Bearer token used for authentication. This can be any class that includes and implements Aws::TokenProvider, or instance of any one of the following classes:

    • Aws::StaticTokenProvider - Used for configuring static, non-refreshing tokens.

    • Aws::SSOTokenProvider - Used for loading tokens from AWS SSO using an access token generated from aws login.

    When :token_provider is not configured directly, the Aws::TokenProviderChain will be used to search for tokens configured for your profile in shared configuration files.

  • :use_dualstack_endpoint (Boolean) —

    When set to true, dualstack enabled endpoints (with .aws TLD) will be used if available.

  • :use_fips_endpoint (Boolean) —

    When set to true, fips compatible endpoints will be used if available. When a fips region is used, the region is normalized and this config is set to true.

  • :validate_params (Boolean) — default: true —

    When true, request parameters are validated before sending the request.

  • :endpoint_provider (Aws::Billing::EndpointProvider) —

    The endpoint provider used to resolve endpoints. Any object that responds to #resolve_endpoint(parameters) where parameters is a Struct similar to Aws::Billing::EndpointParameters.

  • :http_continue_timeout (Float) — default: 1 —

    The number of seconds to wait for a 100-continue response before sending the request body. This option has no effect unless the request has "Expect" header set to "100-continue". Defaults to nil which disables this behaviour. This value can safely be set per request on the session.

  • :http_idle_timeout (Float) — default: 5 —

    The number of seconds a connection is allowed to sit idle before it is considered stale. Stale connections are closed and removed from the pool before making a request.

  • :http_open_timeout (Float) — default: 15 —

    The default number of seconds to wait for response data. This value can safely be set per-request on the session.

  • :http_proxy (URI::HTTP, String) —

    A proxy to send requests through. Formatted like 'http://proxy.com:123'.

  • :http_read_timeout (Float) — default: 60 —

    The default number of seconds to wait for response data. This value can safely be set per-request on the session.

  • :http_wire_trace (Boolean) — default: false —

    When true, HTTP debug output will be sent to the :logger.

  • :on_chunk_received (Proc) —

    When a Proc object is provided, it will be used as callback when each chunk of the response body is received. It provides three arguments: the chunk, the number of bytes received, and the total number of bytes in the response (or nil if the server did not send a content-length).

  • :on_chunk_sent (Proc) —

    When a Proc object is provided, it will be used as callback when each chunk of the request body is sent. It provides three arguments: the chunk, the number of bytes read from the body, and the total number of bytes in the body.

  • :raise_response_errors (Boolean) — default: true —

    When true, response errors are raised.

  • :ssl_ca_bundle (String) —

    Full path to the SSL certificate authority bundle file that should be used when verifying peer certificates. If you do not pass :ssl_ca_bundle or :ssl_ca_directory the the system default will be used if available.

  • :ssl_ca_directory (String) —

    Full path of the directory that contains the unbundled SSL certificate authority files for verifying peer certificates. If you do not pass :ssl_ca_bundle or :ssl_ca_directory the the system default will be used if available.

  • :ssl_ca_store (String) —

    Sets the X509::Store to verify peer certificate.

  • :ssl_cert (OpenSSL::X509::Certificate) —

    Sets a client certificate when creating http connections.

  • :ssl_key (OpenSSL::PKey) —

    Sets a client key when creating http connections.

  • :ssl_timeout (Float) —

    Sets the SSL timeout in seconds

  • :ssl_verify_peer (Boolean) — default: true —

    When true, SSL peer certificates are verified when establishing a connection.



485
486
487
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 485

def initialize(*args)
  super
end

Instance Method Details

#associate_contract(params = {}) ⇒ Struct

Private Pricing contracts let eligible payer accounts manage private pricing agreements with Amazon Web Services. This operation associates a private pricing contract with the caller's Amazon Web Services account. The caller must be a payer (management) account listed on the contract. This operation is idempotent, so retrying a request that already succeeded is safe.

Examples:

Example: Invoke AssociateContract


resp = client.associate_contract({
  contract_arn: "arn:aws:billing::123456789012:contract/1a2b3c4d-5e6f-7a8b-9c0d-111122223333", 
  contract_document_id: "CC OTH XXXXXXXX XXXX TR", 
})

resp.to_h outputs the following:
{
}

Request syntax with placeholder values


resp = client.associate_contract({
  contract_arn: "ArnString", # required
  contract_document_id: "ContractDocumentId", # required
})

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :contract_arn (required, String) —

    The Amazon Resource Name (ARN) of the contract to associate with your account.

  • :contract_document_id (required, String) —

    The contract ID from the contract document. It can be found in the top right corner of your contract's pages. This value confirms that you have access to the contract you are associating.

Returns:

  • (Struct) —

    Returns an empty response.

See Also:



532
533
534
535
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 532

def associate_contract(params = {}, options = {})
  req = build_request(:associate_contract, params)
  req.send_request(options)
end

#associate_source_views(params = {}) ⇒ Types::AssociateSourceViewsResponse

Associates one or more source billing views with an existing billing view. This allows creating aggregate billing views that combine data from multiple sources.

Examples:

Example: Invoke AssociateSourceViews


resp = client.associate_source_views({
  arn: "arn:aws:billing::123456789012:billingview/custom-46f47cb2-a11d-43f3-983d-470b5708a899", 
  source_views: [
    "arn:aws:billing::123456789012:billingview/primary", 
    "arn:aws:billing::123456789012:billingview/custom-d3f9c7e4-8b2f-4a6e-9d3b-2f7c8a1e5f6d", 
  ], 
})

resp.to_h outputs the following:
{
  arn: "arn:aws:billing::123456789012:billingview/custom-46f47cb2-a11d-43f3-983d-470b5708a899", 
}

Request syntax with placeholder values


resp = client.associate_source_views({
  arn: "BillingViewArn", # required
  source_views: ["BillingViewArn"], # required
})

Response structure


resp.arn #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :arn (required, String) —

    The Amazon Resource Name (ARN) of the billing view to associate source views with.

  • :source_views (required, Array<String>) —

    A list of ARNs of the source billing views to associate.

Returns:

See Also:



583
584
585
586
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 583

def associate_source_views(params = {}, options = {})
  req = build_request(:associate_source_views, params)
  req.send_request(options)
end

#cancel_contractual_investment_attestation(params = {}) ⇒ Struct

Cancels a contractual investment attestation. This operation is idempotent, so retrying is safe. You can cancel an attestation only while it is still pending (its isCancellable value is true).

Examples:

Example: Invoke CancelContractualInvestmentAttestation


resp = client.cancel_contractual_investment_attestation({
  attestation_id: "a1b2c3d4-5678-90ab-cdef-111122223333", 
  contract_arn: "arn:aws:billing::123456789012:contract/1a2b3c4d-5e6f-7a8b-9c0d-111122223333", 
  reason: "Example cancellation reason", 
})

resp.to_h outputs the following:
{
}

Request syntax with placeholder values


resp = client.cancel_contractual_investment_attestation({
  attestation_id: "IdentifierString", # required
  contract_arn: "ArnString", # required
  reason: "CancellationReason", # required
})

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :attestation_id (required, String) —

    The identifier of the investment attestation to cancel.

  • :contract_arn (required, String) —

    The Amazon Resource Name (ARN) of the contract that contains the attested investment.

  • :reason (required, String) —

    The reason for the cancellation. This value can be 1 to 80 characters.

Returns:

  • (Struct) —

    Returns an empty response.

See Also:



629
630
631
632
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 629

def cancel_contractual_investment_attestation(params = {}, options = {})
  req = build_request(:cancel_contractual_investment_attestation, params)
  req.send_request(options)
end

#create_billing_view(params = {}) ⇒ Types::CreateBillingViewResponse

Creates a billing view with the specified billing view attributes.

Examples:

Example: Invoke CreateBillingView


resp = client.create_billing_view({
  name: "Example Custom Billing View", 
  data_filter_expression: {
    dimensions: {
      key: "LINKED_ACCOUNT", 
      values: [
        "000000000000", 
      ], 
    }, 
  }, 
  description: "Custom Billing View Example", 
  source_views: [
    "arn:aws:billing::123456789101:billingview/primary", 
  ], 
})

resp.to_h outputs the following:
{
  arn: "arn:aws:billing::123456789101:billingview/custom-46f47cb2-a11d-43f3-983d-470b5708a899", 
  created_at: Time.parse(1719792001), 
}

Request syntax with placeholder values


resp = client.create_billing_view({
  name: "BillingViewName", # required
  description: "BillingViewDescription",
  source_views: ["BillingViewArn"], # required
  data_filter_expression: {
    dimensions: {
      key: "LINKED_ACCOUNT", # required, accepts LINKED_ACCOUNT
      values: ["Value"], # required
    },
    tags: {
      key: "TagKey", # required
      values: ["Value"], # required
    },
    cost_categories: {
      key: "CostCategoryName", # required
      values: ["Value"], # required
    },
    time_range: {
      begin_date_inclusive: Time.now,
      end_date_inclusive: Time.now,
    },
  },
  client_token: "ClientToken",
  resource_tags: [
    {
      key: "ResourceTagKey", # required
      value: "ResourceTagValue",
    },
  ],
})

Response structure


resp.arn #=> String
resp.created_at #=> Time

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :name (required, String) —

    The name of the billing view.

  • :description (String) —

    The description of the billing view.

  • :source_views (required, Array<String>) —

    A list of billing views used as the data source for the custom billing view.

  • :data_filter_expression (Types::Expression) —

    See Expression. Billing view only supports LINKED_ACCOUNT, Tags, and CostCategories.

  • :client_token (String) —

    A unique, case-sensitive identifier you specify to ensure idempotency of the request. Idempotency ensures that an API request completes no more than one time. If the original request completes successfully, any subsequent retries complete successfully without performing any further actions with an idempotent request.

    A suitable default value is auto-generated. You should normally not need to pass this option.**

  • :resource_tags (Array<Types::ResourceTag>) —

    A list of key value map specifying tags associated to the billing view being created.

Returns:

See Also:



740
741
742
743
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 740

def create_billing_view(params = {}, options = {})
  req = build_request(:create_billing_view, params)
  req.send_request(options)
end

#create_contractual_investment_attestation(params = {}) ⇒ Types::CreateContractualInvestmentAttestationResponse

Creates an attestation that claims an investment award for a completed milestone or outcome within a private pricing contract. Supply a clientToken to make the request idempotent so a safe retry does not create a duplicate attestation. This operation starts an asynchronous review and returns an attestationId while the attestation is pending.

Examples:

Example: Invoke CreateContractualInvestmentAttestation with a direct amount


resp = client.create_contractual_investment_attestation({
  additional_recipients: [
    {
      email: "recipient@example.com", 
    }, 
  ], 
  approver_details: {
    name: "First-Name Last-Name", 
    email: "first-name.last-name@example.com", 
    title: "Title", 
  }, 
  attestation_details: {
    attestation_value: {
      attestation_amount: {
        currency_amount: "1.00", 
        currency_code: "USD", 
      }, 
    }, 
    investment_distributions: [
      {
        account_id: "123456789012", 
        investment_amount: {
          currency_amount: "1.00", 
          currency_code: "USD", 
        }, 
      }, 
    ], 
  }, 
  client_token: "c0ffee00-1234-4abc-9def-0123456789ab", 
  contract_arn: "arn:aws:billing::123456789012:contract/1a2b3c4d-5e6f-7a8b-9c0d-111122223333", 
  contract_document_id: "CC OTH XXXXXXXX XXXX TR", 
  investment_disbursed_at: Time.parse(1199923200), 
  investment_id: "Investment-Id", 
  investment_summary_id: "Example-Investment-Summary-Id", 
})

resp.to_h outputs the following:
{
  attestation_id: "a1b2c3d4-5678-90ab-cdef-111122223333", 
}

Example: Invoke CreateContractualInvestmentAttestation with a flat rate multiplier


resp = client.create_contractual_investment_attestation({
  approver_details: {
    name: "First-Name Last-Name", 
    email: "first-name.last-name@example.com", 
    title: "Title", 
  }, 
  attestation_details: {
    attestation_value: {
      attestation_quantities: [
        {
          attestation_unit: "Example attestation unit", 
          attestation_volume: "3", 
        }, 
      ], 
    }, 
    investment_distributions: [
      {
        account_id: "123456789012", 
        investment_amount: {
          currency_amount: "1500.00", 
          currency_code: "USD", 
        }, 
      }, 
    ], 
  }, 
  client_token: "c0ffee00-1234-4abc-9def-0123456789ac", 
  contract_arn: "arn:aws:billing::123456789012:contract/1a2b3c4d-5e6f-7a8b-9c0d-111122223333", 
  contract_document_id: "CC OTH XXXXXXXX XXXX TR", 
  investment_disbursed_at: Time.parse(1199923200), 
  investment_id: "Investment-Id", 
  investment_summary_id: "Example-Investment-Summary-Id", 
})

resp.to_h outputs the following:
{
  attestation_id: "b2c3d4e5-6789-01bc-def0-222233334444", 
}

Example: Invoke CreateContractualInvestmentAttestation with a percentage multiplier


resp = client.create_contractual_investment_attestation({
  approver_details: {
    name: "First-Name Last-Name", 
    email: "first-name.last-name@example.com", 
    title: "Title", 
  }, 
  attestation_details: {
    attestation_value: {
      attestation_quantities: [
        {
          attestation_unit: "Example attestation unit", 
          attestation_volume: "1000", 
        }, 
      ], 
    }, 
    investment_distributions: [
      {
        account_id: "123456789012", 
        investment_amount: {
          currency_amount: "150.00", 
          currency_code: "USD", 
        }, 
      }, 
    ], 
  }, 
  client_token: "c0ffee00-1234-4abc-9def-0123456789ad", 
  contract_arn: "arn:aws:billing::123456789012:contract/1a2b3c4d-5e6f-7a8b-9c0d-111122223333", 
  contract_document_id: "CC OTH XXXXXXXX XXXX TR", 
  investment_disbursed_at: Time.parse(1199923200), 
  investment_id: "Investment-Id", 
  investment_summary_id: "Example-Investment-Summary-Id", 
})

resp.to_h outputs the following:
{
  attestation_id: "c3d4e5f6-7890-12cd-ef01-333344445555", 
}

Request syntax with placeholder values


resp = client.create_contractual_investment_attestation({
  contract_arn: "ArnString", # required
  investment_summary_id: "IdentifierString", # required
  investment_id: "IdentifierString", # required
  contract_document_id: "ContractDocumentId", # required
  approver_details: { # required
    name: "SensitiveString", # required
    title: "SensitiveString", # required
    email: "SensitiveEmail", # required
  },
  investment_disbursed_at: Time.now,
  attestation_details: { # required
    attestation_value: { # required
      attestation_amount: {
        currency_code: "CurrencyCode", # required
        currency_amount: "CurrencyAmount", # required
      },
      attestation_quantities: [
        {
          attestation_volume: "AttestationQuantityAttestationVolumeString", # required
          attestation_unit: "AttestationQuantityAttestationUnitString", # required
        },
      ],
    },
    investment_distributions: [
      {
        account_id: "AccountId", # required
        investment_amount: { # required
          currency_code: "CurrencyCode", # required
          currency_amount: "CurrencyAmount", # required
        },
      },
    ],
  },
  additional_recipients: [
    {
      email: "SensitiveEmail", # required
    },
  ],
  client_token: "AttestationClientToken",
})

Response structure


resp.attestation_id #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :contract_arn (required, String) —

    The Amazon Resource Name (ARN) of the contract that contains the investment being attested.

  • :investment_summary_id (required, String) —

    The identifier of the investment summary being attested. This is the parent to the investmentId.

  • :investment_id (required, String) —

    The identifier of the investment (outcome) being attested.

  • :contract_document_id (required, String) —

    The contract ID from the contract document, located in the top-right corner of the private pricing contract pages. This value confirms that you have access to the contract.

  • :approver_details (required, Types::ApproverDetails) —

    The details of the executive who authorized the attestation, under the terms of the private pricing contract. The executive receives a click-to-accept email to confirm the attestation.

  • :investment_disbursed_at (Time, DateTime, Date, Integer, String) —

    The date on which the investment is disbursed to the investment accounts. The disbursement date is subject to review timelines.

  • :attestation_details (required, Types::AttestationDetails) —

    The details of the attestation, including the value being claimed and how the resulting investment is distributed across investment accounts.

  • :additional_recipients (Array<Types::AdditionalRecipient>) —

    The email addresses to copy as viewers on the executive approval request.

  • :client_token (String) —

    A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. If you retry a request that completed successfully using the same client token and parameters, the retry completes without performing any further actions.

    A suitable default value is auto-generated. You should normally not need to pass this option.**

Returns:

See Also:



975
976
977
978
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 975

def create_contractual_investment_attestation(params = {}, options = {})
  req = build_request(:create_contractual_investment_attestation, params)
  req.send_request(options)
end

#delete_billing_view(params = {}) ⇒ Types::DeleteBillingViewResponse

Deletes the specified billing view.

Examples:

Example: Invoke DeleteBillingView


resp = client.delete_billing_view({
  arn: "arn:aws:billing::123456789101:billingview/custom-46f47cb2-a11d-43f3-983d-470b5708a899", 
})

resp.to_h outputs the following:
{
  arn: "arn:aws:billing::123456789101:billingview/custom-46f47cb2-a11d-43f3-983d-470b5708a899", 
}

Request syntax with placeholder values


resp = client.delete_billing_view({
  arn: "BillingViewArn", # required
  force: false,
})

Response structure


resp.arn #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :arn (required, String) —

    The Amazon Resource Name (ARN) that can be used to uniquely identify the billing view.

  • :force (Boolean) —

    If set to true, forces deletion of the billing view even if it has derived resources (e.g. other billing views or budgets). Use with caution as this may break dependent resources.

Returns:

See Also:



1022
1023
1024
1025
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 1022

def delete_billing_view(params = {}, options = {})
  req = build_request(:delete_billing_view, params)
  req.send_request(options)
end

#disassociate_contract(params = {}) ⇒ Struct

Removes the association between a private pricing contract and your Amazon Web Services account. The account must have been associated with the contract previously. This operation is idempotent, so retrying is safe.

Examples:

Example: Invoke DisassociateContract


resp = client.disassociate_contract({
  contract_arn: "arn:aws:billing::123456789012:contract/1a2b3c4d-5e6f-7a8b-9c0d-111122223333", 
})

resp.to_h outputs the following:
{
}

Request syntax with placeholder values


resp = client.disassociate_contract({
  contract_arn: "ArnString", # required
})

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :contract_arn (required, String) —

    The Amazon Resource Name (ARN) of the contract to disassociate from your account.

Returns:

  • (Struct) —

    Returns an empty response.

See Also:



1059
1060
1061
1062
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 1059

def disassociate_contract(params = {}, options = {})
  req = build_request(:disassociate_contract, params)
  req.send_request(options)
end

#disassociate_source_views(params = {}) ⇒ Types::DisassociateSourceViewsResponse

Removes the association between one or more source billing views and an existing billing view. This allows modifying the composition of aggregate billing views.

Examples:

Example: Invoke DisassociateSourceViews


resp = client.disassociate_source_views({
  arn: "arn:aws:billing::123456789012:billingview/custom-46f47cb2-a11d-43f3-983d-470b5708a899", 
  source_views: [
    "arn:aws:billing::123456789012:billingview/primary", 
    "arn:aws:billing::123456789012:billingview/custom-d3f9c7e4-8b2f-4a6e-9d3b-2f7c8a1e5f6d", 
  ], 
})

resp.to_h outputs the following:
{
  arn: "arn:aws:billing::123456789012:billingview/custom-46f47cb2-a11d-43f3-983d-470b5708a899", 
}

Request syntax with placeholder values


resp = client.disassociate_source_views({
  arn: "BillingViewArn", # required
  source_views: ["BillingViewArn"], # required
})

Response structure


resp.arn #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :arn (required, String) —

    The Amazon Resource Name (ARN) of the billing view to disassociate source views from.

  • :source_views (required, Array<String>) —

    A list of ARNs of the source billing views to disassociate.

Returns:

See Also:



1110
1111
1112
1113
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 1110

def disassociate_source_views(params = {}, options = {})
  req = build_request(:disassociate_source_views, params)
  req.send_request(options)
end

#get_billing_preferences(params = {}) ⇒ Types::GetBillingPreferencesResponse

Retrieves billing preferences for the specified feature. Each feature controls a distinct billing capability: which accounts can share Reserved Instances or credits, whether billing alerts are enabled, the historical record of sharing changes, and per-credit options.

Examples:

Request syntax with placeholder values


resp = client.get_billing_preferences({
  next_token: "PageToken",
  max_results: 1,
  features: ["RI_SHARING"], # required, accepts RI_SHARING, RI_SHARING_HISTORY, CREDIT_SHARING, CREDIT_SHARING_HISTORY, CREDIT_LEVEL_SHARING, BILLING_ALERTS, CREDIT_PREFERENCE_OPTIONS
  filters: [
    {
      name: "PREFERENCE_KEY", # accepts PREFERENCE_KEY
      value: ["BillingFeatureFilterValue"],
    },
  ],
})

Response structure


resp.billing_preferences #=> Array
resp.billing_preferences[0].feature #=> String, one of "RI_SHARING", "RI_SHARING_HISTORY", "CREDIT_SHARING", "CREDIT_SHARING_HISTORY", "CREDIT_LEVEL_SHARING", "BILLING_ALERTS", "CREDIT_PREFERENCE_OPTIONS"
resp.billing_preferences[0].key #=> String
resp.billing_preferences[0].value #=> String, one of "ENABLED", "DISABLED"
resp.billing_preferences[0]. #=> String
resp.billing_preferences[0]. #=> String
resp.billing_preferences[0].billing_period.year #=> Integer
resp.billing_preferences[0].billing_period.month #=> Integer
resp.next_token #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :next_token (String) —

    Pagination token from a previous response. Pass the value returned in nextToken to retrieve the next page of results.

  • :max_results (Integer) —

    The maximum number of records to return per page. Range: 1 to 50. Default: 50.

  • :features (required, Array<String>) —

    The feature to retrieve. Specify exactly one value. Valid values: BILLING_ALERTS, RI_SHARING, RI_SHARING_HISTORY, CREDIT_SHARING, CREDIT_SHARING_HISTORY, CREDIT_LEVEL_SHARING, CREDIT_PREFERENCE_OPTIONS.

  • :filters (Array<Types::BillingFeatureFilter>) —

    Filters to narrow results. Specify exactly one filter when supplied. The supported filter name is PREFERENCE_KEY, which accepts 1 to 10 values to match preference keys.

Returns:

See Also:



1174
1175
1176
1177
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 1174

def get_billing_preferences(params = {}, options = {})
  req = build_request(:get_billing_preferences, params)
  req.send_request(options)
end

#get_billing_view(params = {}) ⇒ Types::GetBillingViewResponse

Returns the metadata associated to the specified billing view ARN.

Examples:

Example: Invoke GetBillingView


resp = client.get_billing_view({
  arn: "arn:aws:billing::123456789101:billingview/custom-46f47cb2-a11d-43f3-983d-470b5708a899", 
})

resp.to_h outputs the following:
{
  billing_view: {
    name: "Example Custom Billing View", 
    arn: "arn:aws:billing::123456789101:billingview/custom-46f47cb2-a11d-43f3-983d-470b5708a899", 
    billing_view_type: "CUSTOM", 
    data_filter_expression: {
      dimensions: {
        key: "LINKED_ACCOUNT", 
        values: [
          "000000000000", 
        ], 
      }, 
    }, 
    description: "Custom Billing View Example -- updated description", 
    owner_account_id: "123456789101", 
  }, 
}

Request syntax with placeholder values


resp = client.get_billing_view({
  arn: "BillingViewArn", # required
})

Response structure


resp.billing_view.arn #=> String
resp.billing_view.name #=> String
resp.billing_view.description #=> String
resp.billing_view.billing_view_type #=> String, one of "PRIMARY", "BILLING_GROUP", "CUSTOM", "BILLING_TRANSFER", "BILLING_TRANSFER_SHOWBACK"
resp.billing_view. #=> String
resp.billing_view. #=> String
resp.billing_view.data_filter_expression.dimensions.key #=> String, one of "LINKED_ACCOUNT"
resp.billing_view.data_filter_expression.dimensions.values #=> Array
resp.billing_view.data_filter_expression.dimensions.values[0] #=> String
resp.billing_view.data_filter_expression.tags.key #=> String
resp.billing_view.data_filter_expression.tags.values #=> Array
resp.billing_view.data_filter_expression.tags.values[0] #=> String
resp.billing_view.data_filter_expression.cost_categories.key #=> String
resp.billing_view.data_filter_expression.cost_categories.values #=> Array
resp.billing_view.data_filter_expression.cost_categories.values[0] #=> String
resp.billing_view.data_filter_expression.time_range.begin_date_inclusive #=> Time
resp.billing_view.data_filter_expression.time_range.end_date_inclusive #=> Time
resp.billing_view.created_at #=> Time
resp.billing_view.updated_at #=> Time
resp.billing_view.derived_view_count #=> Integer
resp.billing_view.source_view_count #=> Integer
resp.billing_view.view_definition_last_updated_at #=> Time
resp.billing_view.health_status.status_code #=> String, one of "HEALTHY", "UNHEALTHY", "CREATING", "UPDATING"
resp.billing_view.health_status.status_reasons #=> Array
resp.billing_view.health_status.status_reasons[0] #=> String, one of "SOURCE_VIEW_UNHEALTHY", "SOURCE_VIEW_UPDATING", "SOURCE_VIEW_ACCESS_DENIED", "SOURCE_VIEW_NOT_FOUND", "CYCLIC_DEPENDENCY", "SOURCE_VIEW_DEPTH_EXCEEDED", "AGGREGATE_SOURCE", "VIEW_OWNER_NOT_MANAGEMENT_ACCOUNT"

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :arn (required, String) —

    The Amazon Resource Name (ARN) that can be used to uniquely identify the billing view.

Returns:

See Also:



1253
1254
1255
1256
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 1253

def get_billing_view(params = {}, options = {})
  req = build_request(:get_billing_view, params)
  req.send_request(options)
end

#get_contract_information(params = {}) ⇒ Types::GetContractInformationResponse

Returns information about a specific private pricing contract, including its term (duration), eligible payer accounts, investment accounts, and legal entities. This operation is read-only.

Examples:

Example: Invoke GetContractInformation


resp = client.get_contract_information({
  contract_arn: "arn:aws:billing::123456789012:contract/1a2b3c4d-5e6f-7a8b-9c0d-111122223333", 
})

resp.to_h outputs the following:
{
  contract: {
    private_pricing_addendum: {
      contract_arn: "arn:aws:billing::123456789012:contract/1a2b3c4d-5e6f-7a8b-9c0d-111122223333", 
      contract_term: {
        end_date_inclusive: Time.parse(1222222222), 
        start_date_inclusive: Time.parse(1111111111), 
      }, 
      eligible_payer_accounts: [
        "123456789012", 
        "210987654321", 
      ], 
      investment_accounts: [
        "123456789012", 
      ], 
      legal_entities: [
        {
          legal_entity_name: "Example Legal Entity Name", 
        }, 
      ], 
    }, 
  }, 
}

Request syntax with placeholder values


resp = client.get_contract_information({
  contract_arn: "ArnString", # required
})

Response structure


resp.contract.private_pricing_addendum.contract_arn #=> String
resp.contract.private_pricing_addendum.contract_term.start_date_inclusive #=> Time
resp.contract.private_pricing_addendum.contract_term.end_date_inclusive #=> Time
resp.contract.private_pricing_addendum.eligible_payer_accounts #=> Array
resp.contract.private_pricing_addendum.eligible_payer_accounts[0] #=> String
resp.contract.private_pricing_addendum.investment_accounts #=> Array
resp.contract.private_pricing_addendum.investment_accounts[0] #=> String
resp.contract.private_pricing_addendum.legal_entities #=> Array
resp.contract.private_pricing_addendum.legal_entities[0].legal_entity_name #=> String
resp.contract.private_pricing_addendum.contract_restrictions #=> Array
resp.contract.private_pricing_addendum.contract_restrictions[0] #=> String, one of "ATTESTATION_SELF_SERVICE_BLOCKED"

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :contract_arn (required, String) —

    The Amazon Resource Name (ARN) of the contract to retrieve information about.

Returns:

See Also:



1326
1327
1328
1329
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 1326

def get_contract_information(params = {}, options = {})
  req = build_request(:get_contract_information, params)
  req.send_request(options)
end

#get_credit_allocation_history(params = {}) ⇒ Types::GetCreditAllocationHistoryResponse

Returns the per-billing-month allocation history for credits applied to an Amazon Web Services account's bills. Traverses the consolidated billing family to capture cross-account credit applications. Supports pagination and optional filtering to a single credit.

The returned response is a pageable response and is Enumerable. For details on usage see PageableResponse.

Examples:

Request syntax with placeholder values


resp = client.get_credit_allocation_history({
  account_id: "AccountId", # required
  credit_id: 1,
  start_date: Time.now, # required
  end_date: Time.now, # required
  next_token: "PageToken",
  max_results: 1,
})

Response structure


resp.credit_allocation_history_list #=> Array
resp.credit_allocation_history_list[0].credit_id #=> String
resp.credit_allocation_history_list[0].credit_amount.currency_code #=> String
resp.credit_allocation_history_list[0].credit_amount.currency_amount #=> String
resp.credit_allocation_history_list[0].description #=> String
resp.credit_allocation_history_list[0]. #=> String
resp.credit_allocation_history_list[0].applied_service_name #=> String
resp.credit_allocation_history_list[0].billing_month #=> String
resp.credit_allocation_history_list[0].is_estimated_bill #=> Boolean
resp.partial_results #=> Boolean
resp.failed_months #=> Array
resp.failed_months[0] #=> String
resp.next_token #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :account_id (required, String) —

    The Amazon Web Services account ID whose allocation history to retrieve. Must be a 12-digit numeric string.

  • :credit_id (Integer) —

    Filters the result to a single credit. When omitted, returns allocation entries for all credits.

  • :start_date (required, Time, DateTime, Date, Integer, String) —

    Inclusive start date as Unix epoch seconds. Must be on or before endDate. The range from startDate to endDate cannot exceed 24 billing months.

  • :end_date (required, Time, DateTime, Date, Integer, String) —

    Inclusive end date as Unix epoch seconds.

  • :next_token (String) —

    Pagination token from a previous response. Pass the value returned in nextToken to retrieve the next page of results.

  • :max_results (Integer) —

    The maximum number of records to return per page. Range: 1 to 1000. Default: 100.

Returns:

See Also:



1400
1401
1402
1403
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 1400

def get_credit_allocation_history(params = {}, options = {})
  req = build_request(:get_credit_allocation_history, params)
  req.send_request(options)
end

#get_credits(params = {}) ⇒ Types::GetCreditsResponse

Returns the list of Amazon Web Services account credits for the specified account. Each credit includes its identifier, type, monetary amounts, applicable products, expiration, sharing configuration, and current enabled status.

When the caller is the management account of a consolidated billing family and payerAccountFlag is true, the response aggregates credits across the entire family. Otherwise, the response includes only credits owned by the account specified in accountId.

Examples:

Request syntax with placeholder values


resp = client.get_credits({
  account_id: "String", # required
  start_date: Time.now, # required
  end_date: Time.now,
  payer_account_flag: false,
})

Response structure


resp.credits #=> Array
resp.credits[0].credit_id #=> String
resp.credits[0]. #=> String
resp.credits[0].credit_type #=> String
resp.credits[0].initial_amount.currency_code #=> String
resp.credits[0].initial_amount.currency_amount #=> String
resp.credits[0].remaining_amount.currency_code #=> String
resp.credits[0].remaining_amount.currency_amount #=> String
resp.credits[0].estimated_amount.currency_code #=> String
resp.credits[0].estimated_amount.currency_amount #=> String
resp.credits[0].applicable_product_names #=> Array
resp.credits[0].applicable_product_names[0] #=> String
resp.credits[0].description #=> String
resp.credits[0].start_date #=> Time
resp.credits[0].end_date #=> Time
resp.credits[0].exhaust_date #=> Time
resp.credits[0].application_type #=> String, one of "BEFORE_CROSS_SERVICE_DISCOUNTS", "AFTER_DISCOUNTS"
resp.credits[0].shareable_accounts #=> Array
resp.credits[0].shareable_accounts[0] #=> String
resp.credits[0]. #=> Boolean
resp.credits[0].credit_console_visibility #=> String
resp.credits[0].credit_sharing_type #=> String, one of "DEFAULT", "DISABLED", "CUSTOM", "COST_CATEGORY_RULE"
resp.credits[0].cost_category_arn #=> String
resp.credits[0].rule_name #=> String
resp.credits[0].credit_status #=> String, one of "ENABLED", "DISABLED"
resp.credits[0].purchase_type_applications #=> Array
resp.credits[0].purchase_type_applications[0] #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :account_id (required, String) —

    The Amazon Web Services account ID. Must be a 12-digit numeric string.

  • :start_date (required, Time, DateTime, Date, Integer, String) —

    The start date for the credit period as Unix epoch seconds. Must be a past date that is not more than one year before the current date.

  • :end_date (Time, DateTime, Date, Integer, String) —

    The end date for the credit period as Unix epoch seconds. Must not be a future date and must be on or after startDate. Defaults to the current date when omitted.

  • :payer_account_flag (Boolean) —

    When true and the caller is the management account, the response aggregates credits across the entire consolidated billing family. When false or omitted, returns only credits for the specified accountId.

Returns:

See Also:



1480
1481
1482
1483
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 1480

def get_credits(params = {}, options = {})
  req = build_request(:get_credits, params)
  req.send_request(options)
end

#get_enterprise_support_charge_summary(params = {}) ⇒ Types::GetEnterpriseSupportChargeSummaryResponse

Returns a summary of Enterprise Support data aggregated across all accounts in the Enterprise Support profile.

Examples:

Request syntax with placeholder values


resp = client.get_enterprise_support_charge_summary({
  billing_month: "EnterpriseSupportBillingMonth", # required
})

Response structure


resp. #=> String
resp.billing_month #=> String
resp.billing_period_start_date #=> Time
resp.billing_period_end_date #=> Time
resp.is_estimated #=> Boolean
resp.bill_date #=> Time
resp.support_charge #=> String
resp.total_support_charge #=> String
resp.support_discount #=> String
resp.total_support_eligible_spend #=> String
resp.total_support_eligible_usage_spend #=> String
resp.total_support_eligible_reserved_instance_spend #=> String
resp.total_support_eligible_savings_plan_spend #=> String
resp.support_charge_percentage #=> String
resp.support_effective_pricing_plan.pricing_plan_id #=> String
resp.support_effective_pricing_plan.name #=> String
resp.support_effective_pricing_plan.description #=> String
resp.support_effective_pricing_plan.start_date #=> Time
resp.support_effective_pricing_plan.end_date #=> Time
resp.support_effective_pricing_plan.plan_discount_percent #=> String
resp.support_effective_pricing_plan.discount_applies_to_minimum_charge #=> Boolean
resp.support_effective_pricing_plan.minimum_charge #=> String
resp.support_effective_pricing_plan.tiered #=> String
resp.support_effective_pricing_plan.tiers #=> Array
resp.support_effective_pricing_plan.tiers[0].tier_minimum #=> String
resp.support_effective_pricing_plan.tiers[0].tier_maximum #=> String
resp.support_effective_pricing_plan.tiers[0].base_charge #=> String
resp.support_effective_pricing_plan.tiers[0].additional_percentage_of_aggregate_charges #=> String
resp.support_effective_pricing_plan.tiers[0].aggregate_charges_adjustment #=> String
resp.support_effective_pricing_plan.tiers[0].incremental #=> Boolean
resp.support_effective_pricing_plan.tiers[0].increment #=> String
resp.support_effective_pricing_plan.tiers[0].increment_charge #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :billing_month (required, String) —

    The billing month in YYYY-MM format. This must be a month in the past.

Returns:

See Also:



1554
1555
1556
1557
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 1554

def get_enterprise_support_charge_summary(params = {}, options = {})
  req = build_request(:get_enterprise_support_charge_summary, params)
  req.send_request(options)
end

#get_enterprise_support_contract_details(params = {}) ⇒ Types::GetEnterpriseSupportContractDetailsResponse

Returns Enterprise Support contract details.

Examples:

Request syntax with placeholder values


resp = client.get_enterprise_support_contract_details({
  billing_month: "EnterpriseSupportBillingMonth", # required
})

Response structure


resp.is_contract_active #=> Boolean
resp.support_allocation_method #=> String
resp.support_reserved_instance_amortization_start_date #=> Time
resp.support_reserved_instance_treatment_method #=> String
resp.support_savings_plans_amortization_start_date #=> Time
resp.support_savings_plans_treatment_method #=> String
resp.support_prorate_start_date #=> Time
resp. #=> Array
resp.[0]. #=> String
resp.[0].is_gdn #=> Boolean
resp. #=> Array
resp.[0]. #=> String
resp.[0].charge_percentage #=> String
resp.additional_support_charge #=> Array
resp.additional_support_charge[0].description #=> String
resp.additional_support_charge[0].amount #=> String
resp.additional_support_charge[0].charge_type #=> String
resp.additional_support_eligible_usage_spend #=> Array
resp.additional_support_eligible_usage_spend[0].description #=> String
resp.additional_support_eligible_usage_spend[0].amount #=> String
resp.additional_support_eligible_usage_spend[0].charge_type #=> String
resp.pricing_plans #=> Array
resp.pricing_plans[0].pricing_plan_id #=> String
resp.pricing_plans[0].name #=> String
resp.pricing_plans[0].description #=> String
resp.pricing_plans[0].start_date #=> Time
resp.pricing_plans[0].end_date #=> Time
resp.pricing_plans[0].plan_discount_percent #=> String
resp.pricing_plans[0].discount_applies_to_minimum_charge #=> Boolean
resp.pricing_plans[0].minimum_charge #=> String
resp.pricing_plans[0].tiered #=> String
resp.pricing_plans[0].tiers #=> Array
resp.pricing_plans[0].tiers[0].tier_minimum #=> String
resp.pricing_plans[0].tiers[0].tier_maximum #=> String
resp.pricing_plans[0].tiers[0].base_charge #=> String
resp.pricing_plans[0].tiers[0].additional_percentage_of_aggregate_charges #=> String
resp.pricing_plans[0].tiers[0].aggregate_charges_adjustment #=> String
resp.pricing_plans[0].tiers[0].incremental #=> Boolean
resp.pricing_plans[0].tiers[0].increment #=> String
resp.pricing_plans[0].tiers[0].increment_charge #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :billing_month (required, String) —

    The billing month in YYYY-MM format. This must be a month in the past.

Returns:

See Also:



1632
1633
1634
1635
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 1632

def get_enterprise_support_contract_details(params = {}, options = {})
  req = build_request(:get_enterprise_support_contract_details, params)
  req.send_request(options)
end

#get_resource_policy(params = {}) ⇒ Types::GetResourcePolicyResponse

Returns the resource-based policy document attached to the resource in JSON format.

Examples:

Example: Invoke GetResourcePolicy


resp = client.get_resource_policy({
  resource_arn: "arn:aws:billing::123456789101:billingview/custom-46f47cb2-a11d-43f3-983d-470b5708a899", 
})

resp.to_h outputs the following:
{
  policy: "{\"Version\":\"2012-10-17\",\"Id\":\"46f47cb2-a11d-43f3-983d-470b5708a899\",\"Statement\":[{\"Sid\":\"ExampleStatement1\",\"Effect\":\"Allow\",\"Principal\":{\"AWS\":\"arn:aws:iam::000000000000:root\"},\"Action\":[\"ce:GetDimensionValues\",\"ce:GetCostAndUsageWithResources\",\"ce:GetCostAndUsage\",\"ce:GetCostForecast\",\"ce:GetTags\",\"ce:GetUsageForecast\",\"ce:GetCostCategories\",\"billing:GetBillingView\"],\"Resource\":\"arn:aws:billing::123456789101:billingview/custom-46f47cb2-a11d-43f3-983d-470b5708a899\"}]}", 
  resource_arn: "arn:aws:billing::123456789101:billingview/custom-46f47cb2-a11d-43f3-983d-470b5708a899", 
}

Request syntax with placeholder values


resp = client.get_resource_policy({
  resource_arn: "ResourceArn", # required
})

Response structure


resp.resource_arn #=> String
resp.policy #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :resource_arn (required, String) —

    The Amazon Resource Name (ARN) of the billing view resource to which the policy is attached to.

Returns:

See Also:



1677
1678
1679
1680
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 1677

def get_resource_policy(params = {}, options = {})
  req = build_request(:get_resource_policy, params)
  req.send_request(options)
end

#list_billing_view_segments(params = {}) ⇒ Types::ListBillingViewSegmentsResponse

Lists the segments of a billing view over a given time period. Each segment identifies the billing domain (PRO_FORMA or BILLABLE) and the account relationships that apply during its time range.

If you don't provide an arn, the response includes segments for the caller's PRIMARY billing view.

If a mid-period change occurs, the response includes multiple segments, each with its own time range. The response omits hidden segments, so the segments it returns might not cover the entire requested time period.

The returned response is a pageable response and is Enumerable. For details on usage see PageableResponse.

Examples:

Example: Invoke ListBillingViewSegments


resp = client.list_billing_view_segments({
  time_range: {
    begin_date_inclusive: Time.parse(1719792000), 
    end_date_exclusive: Time.parse(1722470400), 
  }, 
})

resp.to_h outputs the following:
{
  items: [
    {
      billing_group_primary_account_id: "333333333333", 
      billing_transfer_account_id: "111111111111", 
      domain: "BILLABLE", 
      management_account_id: "222222222222", 
      time_range: {
        begin_date_inclusive: Time.parse(1719792000), 
        end_date_exclusive: Time.parse(1722470400), 
      }, 
    }, 
  ], 
}

Example: Error example for ListBillingViewSegments


resp = client.list_billing_view_segments({
  time_range: {
    begin_date_inclusive: Time.parse(1722470400), 
    end_date_exclusive: Time.parse(1719792000), 
  }, 
})

Request syntax with placeholder values


resp = client.list_billing_view_segments({
  time_range: {
    begin_date_inclusive: Time.now,
    end_date_exclusive: Time.now,
  },
  arn: "BillingViewArn",
  max_results: 1,
  next_token: "PageToken",
})

Response structure


resp.items #=> Array
resp.items[0].domain #=> String, one of "BILLABLE", "PRO_FORMA"
resp.items[0].time_range.begin_date_inclusive #=> Time
resp.items[0].time_range.end_date_exclusive #=> Time
resp.items[0]. #=> String
resp.items[0]. #=> String
resp.items[0]. #=> String
resp.next_token #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :time_range (Types::BillingViewSegmentTimeRange) —

    The billing period to query. If you don't provide a time range, the current billing period, which is the calendar month in UTC, is used.

  • :arn (String) —

    The Amazon Resource Name (ARN) that uniquely identifies the billing view to query. If you don't provide an ARN, the caller's PRIMARY billing view is used. The ARN must reference a primary billing view. Custom billing views aren't supported.

  • :max_results (Integer) —

    The number of entries a paginated response contains. Valid values range from 1 to 100. The default is 100.

  • :next_token (String) —

    The pagination token that is used on subsequent calls to list billing view segments.

Returns:

See Also:



1781
1782
1783
1784
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 1781

def list_billing_view_segments(params = {}, options = {})
  req = build_request(:list_billing_view_segments, params)
  req.send_request(options)
end

#list_billing_views(params = {}) ⇒ Types::ListBillingViewsResponse

Lists the billing views available for a given time period.

Every Amazon Web Services account has a unique PRIMARY billing view that represents the billing data available by default. Accounts that use Billing Conductor also have BILLING_GROUP billing views representing pro forma costs associated with each created billing group.

The returned response is a pageable response and is Enumerable. For details on usage see PageableResponse.

Examples:

Example: Invoke ListBillingViews


resp = client.list_billing_views({
  active_time_range: {
    active_after_inclusive: Time.parse(1719792000), 
    active_before_inclusive: Time.parse(1722470399.999), 
  }, 
})

resp.to_h outputs the following:
{
  billing_views: [
    {
      name: "Primary Billing View Account 123456789101", 
      arn: "arn:aws:billing::123456789101:billingview/primary", 
      billing_view_type: "PRIMARY", 
      owner_account_id: "123456789101", 
    }, 
  ], 
}

Example: Error example for ListBillingViews


resp = client.list_billing_views({
  active_time_range: {
    active_after_inclusive: Time.parse(1719792001), 
    active_before_inclusive: Time.parse(1719792000), 
  }, 
})

Request syntax with placeholder values


resp = client.list_billing_views({
  active_time_range: {
    active_after_inclusive: Time.now, # required
    active_before_inclusive: Time.now, # required
  },
  arns: ["BillingViewArn"],
  billing_view_types: ["PRIMARY"], # accepts PRIMARY, BILLING_GROUP, CUSTOM, BILLING_TRANSFER, BILLING_TRANSFER_SHOWBACK
  names: [
    {
      search_option: "STARTS_WITH", # required, accepts STARTS_WITH
      search_value: "SearchValue", # required
    },
  ],
  owner_account_id: "AccountId",
  source_account_id: "AccountId",
  max_results: 1,
  next_token: "PageToken",
})

Response structure


resp.billing_views #=> Array
resp.billing_views[0].arn #=> String
resp.billing_views[0].name #=> String
resp.billing_views[0].description #=> String
resp.billing_views[0]. #=> String
resp.billing_views[0]. #=> String
resp.billing_views[0].billing_view_type #=> String, one of "PRIMARY", "BILLING_GROUP", "CUSTOM", "BILLING_TRANSFER", "BILLING_TRANSFER_SHOWBACK"
resp.billing_views[0].health_status.status_code #=> String, one of "HEALTHY", "UNHEALTHY", "CREATING", "UPDATING"
resp.billing_views[0].health_status.status_reasons #=> Array
resp.billing_views[0].health_status.status_reasons[0] #=> String, one of "SOURCE_VIEW_UNHEALTHY", "SOURCE_VIEW_UPDATING", "SOURCE_VIEW_ACCESS_DENIED", "SOURCE_VIEW_NOT_FOUND", "CYCLIC_DEPENDENCY", "SOURCE_VIEW_DEPTH_EXCEEDED", "AGGREGATE_SOURCE", "VIEW_OWNER_NOT_MANAGEMENT_ACCOUNT"
resp.next_token #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :active_time_range (Types::ActiveTimeRange) —

    The time range for the billing views listed. PRIMARY billing view is always listed. BILLING_GROUP billing views are listed for time ranges when the associated billing group resource in Billing Conductor is active. The time range must be within one calendar month.

  • :arns (Array<String>) —

    The Amazon Resource Name (ARN) that can be used to uniquely identify the billing view.

  • :billing_view_types (Array<String>) —

    The type of billing view.

  • :names (Array<Types::StringSearch>) —

    Filters the list of billing views by name. You can specify search criteria to match billing view names based on the search option provided.

  • :owner_account_id (String) —

    The list of owners of the billing view.

  • :source_account_id (String) —

    Filters the results to include only billing views that use the specified account as a source.

  • :max_results (Integer) —

    The maximum number of billing views to retrieve. Default is 100.

  • :next_token (String) —

    The pagination token that is used on subsequent calls to list billing views.

Returns:

See Also:



1903
1904
1905
1906
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 1903

def list_billing_views(params = {}, options = {})
  req = build_request(:list_billing_views, params)
  req.send_request(options)
end

#list_business_support_account_charges(params = {}) ⇒ Types::ListBusinessSupportAccountChargesResponse

Returns Business Support charges broken down at the linked account level for a given billing month.

The returned response is a pageable response and is Enumerable. For details on usage see PageableResponse.

Examples:

Request syntax with placeholder values


resp = client.({
  billing_month: "BusinessSupportBillingMonth", # required
  account_id: "AccountId",
  max_results: 1,
  next_token: "PageToken",
})

Response structure


resp.billing_month #=> String
resp.is_estimated #=> Boolean
resp.total_support_charge #=> String
resp.total_support_eligible_spend #=> String
resp. #=> Integer
resp. #=> Array
resp.[0]. #=> String
resp.[0].support_plan_name #=> String
resp.[0].total_charge #=> String
resp.[0].total_usage_basis #=> String
resp.[0].tier_charges #=> Array
resp.[0].tier_charges[0].tier_description #=> String
resp.[0].tier_charges[0].tier_rate #=> String
resp.[0].tier_charges[0].usage_slice #=> String
resp.[0].tier_charges[0].tier_charge #=> String
resp.[0].tier_charges[0].charge_period_start_date #=> Time
resp.[0].tier_charges[0].charge_period_end_date #=> Time
resp.[0].support_discount.discount_amount #=> String
resp.[0].support_discount.discount_percentage #=> String
resp.[0].support_discount.discount_type #=> String
resp.[0].support_discount.discount_source #=> String
resp.[0].support_eligible_spend_by_service #=> Array
resp.[0].support_eligible_spend_by_service[0].contributing_service #=> String
resp.[0].support_eligible_spend_by_service[0].item_type #=> String
resp.[0].support_eligible_spend_by_service[0].description #=> String
resp.[0].support_eligible_spend_by_service[0].charge_amount #=> String
resp.[0].support_eligible_spend_by_service[0].currency #=> String
resp.next_token #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :billing_month (required, String) —

    The billing month to retrieve Business Support charges for, in YYYY-MM format. You can request the current month (charges will be estimated) or a past month (charges will be finalized).

  • :account_id (String) —

    The linked account ID to filter results to a specific account. If you don't specify a value, the response includes charges for all linked accounts.

  • :max_results (Integer) —

    The maximum number of results to return per page. Default is 100.

  • :next_token (String) —

    The pagination token for the next page of results.

Returns:

See Also:



1983
1984
1985
1986
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 1983

def (params = {}, options = {})
  req = build_request(:list_business_support_account_charges, params)
  req.send_request(options)
end

#list_business_support_subscription_history(params = {}) ⇒ Types::ListBusinessSupportSubscriptionHistoryResponse

Returns the history of Business Support subscription contracts across accounts.

The returned response is a pageable response and is Enumerable. For details on usage see PageableResponse.

Examples:

Request syntax with placeholder values


resp = client.list_business_support_subscription_history({
  billing_month: "BusinessSupportBillingMonth",
  account_id: "AccountId",
  start_date: Time.now,
  end_date: Time.now,
  max_results: 1,
  next_token: "PageToken",
})

Response structure


resp.subscription_contracts #=> Array
resp.subscription_contracts[0]. #=> String
resp.subscription_contracts[0].plan_name #=> String
resp.subscription_contracts[0].contract_start_date #=> Time
resp.subscription_contracts[0].contract_end_date #=> Time
resp.next_token #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :billing_month (String) —

    The billing month to retrieve subscription contracts for, in YYYY-MM format. If you don't specify a value, defaults to the current month.

  • :account_id (String) —

    The account ID to filter results to a specific account. If you don't specify a value, the response includes subscription history for all accounts.

  • :start_date (Time, DateTime, Date, Integer, String) —

    The start date to filter subscription contracts from.

  • :end_date (Time, DateTime, Date, Integer, String) —

    The end date to filter subscription contracts to.

  • :max_results (Integer) —

    The maximum number of results to return per page. Default is 100.

  • :next_token (String) —

    The pagination token for the next page of results.

Returns:

See Also:



2043
2044
2045
2046
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 2043

def list_business_support_subscription_history(params = {}, options = {})
  req = build_request(:list_business_support_subscription_history, params)
  req.send_request(options)
end

#list_contracts(params = {}) ⇒ Types::ListContractsResponse

Lists the private pricing contracts that your Amazon Web Services account is an eligible payer account of. This operation is read-only and paginated.

The returned response is a pageable response and is Enumerable. For details on usage see PageableResponse.

Examples:

Example: Invoke ListContracts


resp = client.list_contracts({
  max_results: 100, 
})

resp.to_h outputs the following:
{
  items: [
    {
      association_status: "ASSOCIATED", 
      contract_arn: "arn:aws:billing::123456789012:contract/1a2b3c4d-5e6f-7a8b-9c0d-111122223333", 
      contract_term: {
        end_date_inclusive: Time.parse(1222222222), 
        start_date_inclusive: Time.parse(1111111111), 
      }, 
      contract_type: "Cross-Service", 
    }, 
  ], 
}

Request syntax with placeholder values


resp = client.list_contracts({
  next_token: "PageToken",
  max_results: 1,
})

Response structure


resp.items #=> Array
resp.items[0].contract_arn #=> String
resp.items[0].contract_term.start_date_inclusive #=> Time
resp.items[0].contract_term.end_date_inclusive #=> Time
resp.items[0].contract_type #=> String, one of "Cross-Service", "Service-Specific", "Other"
resp.items[0].association_status #=> String, one of "ASSOCIATED", "NOT_ASSOCIATED"
resp.items[0].last_updated_at #=> Time
resp.next_token #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :next_token (String) —

    The pagination token that indicates the next set of results to retrieve.

  • :max_results (Integer) —

    The maximum number of contracts to return in a single call. Minimum value of 1, maximum value of 100.

Returns:

See Also:



2111
2112
2113
2114
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 2111

def list_contracts(params = {}, options = {})
  req = build_request(:list_contracts, params)
  req.send_request(options)
end

#list_contractual_investment_attestations(params = {}) ⇒ Types::ListContractualInvestmentAttestationsResponse

Lists the investment attestations submitted under a specific private pricing contract. Use this operation to track attestation status, including the terminal statuses DISBURSED, REJECTED, and CANCELLED. This operation is read-only and paginated.

The returned response is a pageable response and is Enumerable. For details on usage see PageableResponse.

Examples:

Example: Invoke ListContractualInvestmentAttestations


resp = client.list_contractual_investment_attestations({
  contract_arn: "arn:aws:billing::123456789012:contract/1a2b3c4d-5e6f-7a8b-9c0d-111122223333", 
  max_results: 25, 
})

resp.to_h outputs the following:
{
  items: [
    {
      attestation_id: "a1b2c3d4-5678-90ab-cdef-111122223333", 
      attestation_status: "PENDING_CANCELLATION", 
      attested_at: Time.parse(1333333333), 
      attested_value: {
        currency_amount: "1.00", 
        currency_code: "USD", 
      }, 
      investment_id: "Investment-Id", 
      investment_name: "Example Investment Name", 
      investment_summary_id: "Example-Investment-Summary-Id", 
      outcome_description: "Example outcome description", 
      updated_at: Time.parse(1444444444), 
    }, 
    {
      attestation_id: "b2c3d4e5-6789-01bc-def0-222233334444", 
      attestation_status: "CANCELLED", 
      attested_at: Time.parse(1555555555), 
      attested_value: {
        currency_amount: "1.00", 
        currency_code: "USD", 
      }, 
      investment_id: "Investment-Id", 
      investment_name: "Example Investment Name", 
      investment_summary_id: "Example-Investment-Summary-Id", 
      outcome_description: "Example outcome description", 
      updated_at: Time.parse(1666666666), 
    }, 
  ], 
}

Request syntax with placeholder values


resp = client.list_contractual_investment_attestations({
  contract_arn: "ArnString", # required
  investment_summary_id: "IdentifierString",
  next_token: "PageToken",
  max_results: 1,
})

Response structure


resp.items #=> Array
resp.items[0].attestation_id #=> String
resp.items[0].investment_name #=> String
resp.items[0].outcome_description #=> String
resp.items[0].investment_summary_id #=> String
resp.items[0].investment_id #=> String
resp.items[0].attested_at #=> Time
resp.items[0].updated_at #=> Time
resp.items[0].attestation_status #=> String, one of "PENDING_REVIEW", "PENDING_C_LEVEL_APPROVAL", "PENDING_CANCELLATION", "REJECTED", "CANCELLED", "DISBURSED"
resp.items[0].investment_disbursed_at #=> Time
resp.items[0].attested_value.currency_code #=> String
resp.items[0].attested_value.currency_amount #=> String
resp.items[0].investment_distributions #=> Array
resp.items[0].investment_distributions[0]. #=> String
resp.items[0].investment_distributions[0].investment_amount.currency_code #=> String
resp.items[0].investment_distributions[0].investment_amount.currency_amount #=> String
resp.items[0].rejection_reasons #=> Array
resp.items[0].rejection_reasons[0] #=> String
resp.items[0].is_cancellable #=> Boolean
resp.next_token #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :contract_arn (required, String) —

    The Amazon Resource Name (ARN) of the contract whose attestations you want to list.

  • :investment_summary_id (String) —

    The identifier of a specific investment summary to filter the attestations by. If omitted, attestations for all investment summaries in the contract are returned.

  • :next_token (String) —

    The pagination token that indicates the next set of results to retrieve.

  • :max_results (Integer) —

    The maximum number of attestations to return in a single call. Minimum value of 1, maximum value of 100.

Returns:

See Also:



2223
2224
2225
2226
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 2223

def list_contractual_investment_attestations(params = {}, options = {})
  req = build_request(:list_contractual_investment_attestations, params)
  req.send_request(options)
end

#list_contractual_investment_summaries(params = {}) ⇒ Types::ListContractualInvestmentSummariesResponse

Lists the investment summaries within a specific private pricing contract. This operation is read-only and paginated.

The returned response is a pageable response and is Enumerable. For details on usage see PageableResponse.

Examples:

Example: Invoke ListContractualInvestmentSummaries


resp = client.list_contractual_investment_summaries({
  contract_arn: "arn:aws:billing::123456789012:contract/1a2b3c4d-5e6f-7a8b-9c0d-111122223333", 
  max_results: 100, 
})

resp.to_h outputs the following:
{
  items: [
    {
      investment_name: "Example Investment Name", 
      investment_summary_id: "Example-Investment-Summary-Id", 
      investment_type: "OUTCOME_BASED", 
      max_allowed_investment_disbursement_value: {
        currency_amount: "100000000.00", 
        currency_code: "USD", 
      }, 
    }, 
  ], 
}

Request syntax with placeholder values


resp = client.list_contractual_investment_summaries({
  contract_arn: "ArnString", # required
  next_token: "PageToken",
  max_results: 1,
})

Response structure


resp.items #=> Array
resp.items[0].investment_summary_id #=> String
resp.items[0].investment_name #=> String
resp.items[0].investment_type #=> String, one of "MILESTONE_BASED", "OUTCOME_BASED"
resp.items[0].max_allowed_investment_disbursement_value.currency_code #=> String
resp.items[0].max_allowed_investment_disbursement_value.currency_amount #=> String
resp.next_token #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :contract_arn (required, String) —

    The Amazon Resource Name (ARN) of the contract whose investment summaries you want to list.

  • :next_token (String) —

    The pagination token that indicates the next set of results to retrieve.

  • :max_results (Integer) —

    The maximum number of investment summaries to return in a single call. Minimum value of 1, maximum value of 100.

Returns:

See Also:



2295
2296
2297
2298
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 2295

def list_contractual_investment_summaries(params = {}, options = {})
  req = build_request(:list_contractual_investment_summaries, params)
  req.send_request(options)
end

#list_contractual_investments(params = {}) ⇒ Types::ListContractualInvestmentsResponse

Lists the investments within a specific investment summary. This operation is read-only and paginated.

The returned response is a pageable response and is Enumerable. For details on usage see PageableResponse.

Examples:

Example: Invoke ListContractualInvestments


resp = client.list_contractual_investments({
  contract_arn: "arn:aws:billing::123456789012:contract/1a2b3c4d-5e6f-7a8b-9c0d-111122223333", 
  investment_summary_id: "Example-Investment-Summary-Id", 
  max_results: 100, 
})

resp.to_h outputs the following:
{
  items: [
    {
      outcome_based_investment: {
        attestation_window: {
          end_date_inclusive: Time.parse(1222222222), 
          start_date_inclusive: Time.parse(1111111111), 
        }, 
        disbursed_value: {
          currency_amount: "0.00", 
          currency_code: "USD", 
        }, 
        investment_id: "Investment-Id", 
        investment_restrictions: [
          {
            amount: {
              currency_amount: "50000.00", 
              currency_code: "USD", 
            }, 
          }, 
        ], 
        outcome_description: "Example outcome description", 
      }, 
    }, 
  ], 
}

Request syntax with placeholder values


resp = client.list_contractual_investments({
  contract_arn: "ArnString", # required
  investment_summary_id: "IdentifierString", # required
  next_token: "PageToken",
  max_results: 1,
})

Response structure


resp.items #=> Array
resp.items[0].milestone_based_investment.investment_id #=> String
resp.items[0].milestone_based_investment.investment_value.currency_code #=> String
resp.items[0].milestone_based_investment.investment_value.currency_amount #=> String
resp.items[0].milestone_based_investment.investment_disbursed_at #=> Time
resp.items[0].outcome_based_investment.investment_id #=> String
resp.items[0].outcome_based_investment.outcome_description #=> String
resp.items[0].outcome_based_investment.attestation_window.start_date_inclusive #=> Time
resp.items[0].outcome_based_investment.attestation_window.end_date_inclusive #=> Time
resp.items[0].outcome_based_investment.investment_restrictions #=> Array
resp.items[0].outcome_based_investment.investment_restrictions[0].amount.currency_code #=> String
resp.items[0].outcome_based_investment.investment_restrictions[0].amount.currency_amount #=> String
resp.items[0].outcome_based_investment.investment_multipliers #=> Array
resp.items[0].outcome_based_investment.investment_multipliers[0].value #=> String
resp.items[0].outcome_based_investment.investment_multipliers[0].investment_attestation_input_unit #=> String
resp.items[0].outcome_based_investment.investment_multipliers[0].multiplier_type #=> String, one of "PERCENTAGE", "CURRENCY_AMOUNT"
resp.items[0].outcome_based_investment.disbursed_value.currency_code #=> String
resp.items[0].outcome_based_investment.disbursed_value.currency_amount #=> String
resp.next_token #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :contract_arn (required, String) —

    The Amazon Resource Name (ARN) of the contract that contains the investment summary.

  • :investment_summary_id (required, String) —

    The identifier of the investment summary whose investments you want to list.

  • :next_token (String) —

    The pagination token that indicates the next set of results to retrieve.

  • :max_results (Integer) —

    The maximum number of investments to return in a single call. Minimum value of 1, maximum value of 100.

Returns:

See Also:



2398
2399
2400
2401
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 2398

def list_contractual_investments(params = {}, options = {})
  req = build_request(:list_contractual_investments, params)
  req.send_request(options)
end

#list_enterprise_support_linked_account_charges(params = {}) ⇒ Types::ListEnterpriseSupportLinkedAccountChargesResponse

Returns Support-eligible spend broken down at linked account level.

The returned response is a pageable response and is Enumerable. For details on usage see PageableResponse.

Examples:

Request syntax with placeholder values


resp = client.({
  billing_month: "EnterpriseSupportBillingMonth", # required
  account_id: "AccountId",
  max_results: 1,
  next_token: "PageToken",
})

Response structure


resp. #=> Array
resp.[0]. #=> String
resp.[0]. #=> String
resp.[0]. #=> String
resp.[0].billable_seconds #=> Integer
resp.[0].total_seconds #=> Integer
resp.[0].total_support_eligible_spend #=> String
resp.[0].prorated_total_support_eligible_spend #=> String
resp.[0].linked_time_periods #=> Array
resp.[0].linked_time_periods[0].begin_date #=> Time
resp.[0].linked_time_periods[0].end_date #=> Time
resp.[0].subscription_time_periods #=> Array
resp.[0].subscription_time_periods[0].begin_date #=> Time
resp.[0].subscription_time_periods[0].end_date #=> Time
resp.[0].total_support_eligible_reserved_instance_spend #=> String
resp.[0].total_support_eligible_savings_plan_spend #=> String
resp.[0].support_eligible_spend_by_service #=> Array
resp.[0].support_eligible_spend_by_service[0].service_code #=> String
resp.[0].support_eligible_spend_by_service[0].total_support_eligible_spend #=> String
resp.next_token #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :billing_month (required, String) —

    The billing month in YYYY-MM format. This must be a month in the past.

  • :account_id (String) —

    The linked account ID to filter results to a specific account. If you don't specify a value, the response includes charges for all linked accounts.

  • :max_results (Integer) —

    The maximum number of results to return per page. Default is 100.

  • :next_token (String) —

    The pagination token for the next page of results.

Returns:

See Also:



2462
2463
2464
2465
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 2462

def (params = {}, options = {})
  req = build_request(:list_enterprise_support_linked_account_charges, params)
  req.send_request(options)
end

#list_source_views_for_billing_view(params = {}) ⇒ Types::ListSourceViewsForBillingViewResponse

Lists the source views (managed Amazon Web Services billing views) associated with the billing view.

The returned response is a pageable response and is Enumerable. For details on usage see PageableResponse.

Examples:

Example: Invoke ListSourceViewsForBillingView


resp = client.list_source_views_for_billing_view({
  arn: "arn:aws:billing::123456789101:billingview/custom-46f47cb2-a11d-43f3-983d-470b5708a899", 
})

resp.to_h outputs the following:
{
  source_views: [
    "arn:aws:billing::123456789101:billingview/primary", 
  ], 
}

Request syntax with placeholder values


resp = client.list_source_views_for_billing_view({
  arn: "BillingViewArn", # required
  max_results: 1,
  next_token: "PageToken",
})

Response structure


resp.source_views #=> Array
resp.source_views[0] #=> String
resp.next_token #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :arn (required, String) —

    The Amazon Resource Name (ARN) that can be used to uniquely identify the billing view.

  • :max_results (Integer) —

    The number of entries a paginated response contains.

  • :next_token (String) —

    The pagination token that is used on subsequent calls to list billing views.

Returns:

See Also:



2520
2521
2522
2523
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 2520

def list_source_views_for_billing_view(params = {}, options = {})
  req = build_request(:list_source_views_for_billing_view, params)
  req.send_request(options)
end

#list_tags_for_resource(params = {}) ⇒ Types::ListTagsForResourceResponse

Lists tags associated with the billing view resource.

Examples:

Example: Invoke ListTagsForResource


resp = client.list_tags_for_resource({
  resource_arn: "arn:aws:billing::123456789101:billingview/custom-46f47cb2-a11d-43f3-983d-470b5708a899", 
})

resp.to_h outputs the following:
{
  resource_tags: [
    {
      key: "ExampleTagKey", 
      value: "ExampleTagValue", 
    }, 
  ], 
}

Request syntax with placeholder values


resp = client.list_tags_for_resource({
  resource_arn: "ResourceArn", # required
})

Response structure


resp.resource_tags #=> Array
resp.resource_tags[0].key #=> String
resp.resource_tags[0].value #=> String

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :resource_arn (required, String) —

    The Amazon Resource Name (ARN) of the resource.

Returns:

See Also:



2567
2568
2569
2570
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 2567

def list_tags_for_resource(params = {}, options = {})
  req = build_request(:list_tags_for_resource, params)
  req.send_request(options)
end

#redeem_credits(params = {}) ⇒ Struct

Redeems an Amazon Web Services promotional credit code on behalf of the calling account. On success, a new credit is added to the account's credit ledger with the amount, validity period, and applicable products defined by the promotion. The credit is then automatically applied to subsequent bills according to the standard credit application order.

Examples:

Request syntax with placeholder values


resp = client.redeem_credits({
  promo_code: "PromoCode", # required
})

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :promo_code (required, String) —

    The promotional credit code to redeem.

Returns:

  • (Struct) —

    Returns an empty response.

See Also:



2594
2595
2596
2597
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 2594

def redeem_credits(params = {}, options = {})
  req = build_request(:redeem_credits, params)
  req.send_request(options)
end

#tag_resource(params = {}) ⇒ Struct

An API operation for adding one or more tags (key-value pairs) to a resource.

Examples:

Example: Invoke TagResource


resp = client.tag_resource({
  resource_arn: "arn:aws:billing::123456789101:billingview/custom-46f47cb2-a11d-43f3-983d-470b5708a899", 
  resource_tags: [
    {
      key: "ExampleTagKey", 
      value: "ExampleTagValue", 
    }, 
  ], 
})

resp.to_h outputs the following:
{
}

Request syntax with placeholder values


resp = client.tag_resource({
  resource_arn: "ResourceArn", # required
  resource_tags: [ # required
    {
      key: "ResourceTagKey", # required
      value: "ResourceTagValue",
    },
  ],
})

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :resource_arn (required, String) —

    The Amazon Resource Name (ARN) of the resource.

  • :resource_tags (required, Array<Types::ResourceTag>) —

    A list of tag key value pairs that are associated with the resource.

Returns:

  • (Struct) —

    Returns an empty response.

See Also:



2643
2644
2645
2646
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 2643

def tag_resource(params = {}, options = {})
  req = build_request(:tag_resource, params)
  req.send_request(options)
end

#untag_resource(params = {}) ⇒ Struct

Removes one or more tags from a resource. Specify only tag keys in your request. Don't specify the value.

Examples:

Example: Invoke UntagResource


resp = client.untag_resource({
  resource_arn: "arn:aws:billing::123456789101:billingview/custom-46f47cb2-a11d-43f3-983d-470b5708a899", 
  resource_tag_keys: [
    "ExampleTagKey", 
  ], 
})

resp.to_h outputs the following:
{
}

Request syntax with placeholder values


resp = client.untag_resource({
  resource_arn: "ResourceArn", # required
  resource_tag_keys: ["ResourceTagKey"], # required
})

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :resource_arn (required, String) —

    The Amazon Resource Name (ARN) of the resource.

  • :resource_tag_keys (required, Array<String>) —

    A list of tag key value pairs that are associated with the resource.

Returns:

  • (Struct) —

    Returns an empty response.

See Also:



2684
2685
2686
2687
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 2684

def untag_resource(params = {}, options = {})
  req = build_request(:untag_resource, params)
  req.send_request(options)
end

#update_billing_preferences(params = {}) ⇒ Struct

Updates billing preferences for the specified feature. Each feature targets a distinct billing capability and has its own set of supported keys. The action sets the value for each provided key; keys not present in the request are unchanged.

Sharing keys (RI_SHARING, CREDIT_SHARING, CREDIT_LEVEL_SHARING, and sharing keys under CREDIT_PREFERENCE_OPTIONS) may only be set by the management account of a consolidated billing family. The credit/{creditId}/status key may be set by member accounts for credits they own, or by the management account for any credit in the family.

Examples:

Request syntax with placeholder values


resp = client.update_billing_preferences({
  feature: "RI_SHARING", # required, accepts RI_SHARING, RI_SHARING_HISTORY, CREDIT_SHARING, CREDIT_SHARING_HISTORY, CREDIT_LEVEL_SHARING, BILLING_ALERTS, CREDIT_PREFERENCE_OPTIONS
  billing_preferences_per_key: [ # required
    {
      key: "PreferenceKey", # required
      value: "ENABLED", # required, accepts ENABLED, DISABLED
    },
  ],
})

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :feature (required, String) —

    The feature to update. Valid values: BILLING_ALERTS, RI_SHARING, CREDIT_SHARING, CREDIT_LEVEL_SHARING, CREDIT_PREFERENCE_OPTIONS. The history features (RI_SHARING_HISTORY and CREDIT_SHARING_HISTORY) are read-only and cannot be updated.

  • :billing_preferences_per_key (required, Array<Types::BillingPreferenceForKey>) —

    Key/value pairs to apply. All keys in a single request must be valid for the specified feature and must not be duplicated. For CREDIT_PREFERENCE_OPTIONS, all keys must reference the same creditId.

Returns:

  • (Struct) —

    Returns an empty response.

See Also:



2731
2732
2733
2734
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 2731

def update_billing_preferences(params = {}, options = {})
  req = build_request(:update_billing_preferences, params)
  req.send_request(options)
end

#update_billing_view(params = {}) ⇒ Types::UpdateBillingViewResponse

An API to update the attributes of the billing view.

Examples:

Example: Invoke UpdateBillingView


resp = client.update_billing_view({
  name: "Example Custom Billing View", 
  arn: "arn:aws:billing::123456789101:billingview/custom-46f47cb2-a11d-43f3-983d-470b5708a899", 
  data_filter_expression: {
    dimensions: {
      key: "LINKED_ACCOUNT", 
      values: [
        "000000000000", 
      ], 
    }, 
  }, 
  description: "Custom Billing View Example -- updated description", 
})

resp.to_h outputs the following:
{
  arn: "arn:aws:billing::123456789101:billingview/custom-46f47cb2-a11d-43f3-983d-470b5708a899", 
  updated_at: Time.parse(1719792001), 
}

Request syntax with placeholder values


resp = client.update_billing_view({
  arn: "BillingViewArn", # required
  name: "BillingViewName",
  description: "BillingViewDescription",
  data_filter_expression: {
    dimensions: {
      key: "LINKED_ACCOUNT", # required, accepts LINKED_ACCOUNT
      values: ["Value"], # required
    },
    tags: {
      key: "TagKey", # required
      values: ["Value"], # required
    },
    cost_categories: {
      key: "CostCategoryName", # required
      values: ["Value"], # required
    },
    time_range: {
      begin_date_inclusive: Time.now,
      end_date_inclusive: Time.now,
    },
  },
})

Response structure


resp.arn #=> String
resp.updated_at #=> Time

Parameters:

  • params (Hash) (defaults to: {}) —

    ({})

Options Hash (params):

  • :arn (required, String) —

    The Amazon Resource Name (ARN) that can be used to uniquely identify the billing view.

  • :name (String) —

    The name of the billing view.

  • :description (String) —

    The description of the billing view.

  • :data_filter_expression (Types::Expression) —

    See Expression. Billing view only supports LINKED_ACCOUNT, Tags, and CostCategories.

Returns:

See Also:



2819
2820
2821
2822
# File 'gems/aws-sdk-billing/lib/aws-sdk-billing/client.rb', line 2819

def update_billing_view(params = {}, options = {})
  req = build_request(:update_billing_view, params)
  req.send_request(options)
end